;/* Bxbasm.INC */
;
;	*************BxbAsm Compiler*************
;	Copyright: sarbayo (c) 2004-2012
; =========================================================================
    .386

    .code

;  FUNCTIONS  FUNCTIONS  FUNCTIONS 
; 

; 

;dwtoa proc dwValue:DWORD, lpBuffer:DWORD
;        
;    ; -------------------------------------------------------------
;    ; convert DWORD to ascii string
;    ; dwValue is value to be converted
;    ; lpBuffer is the address of the receiving buffer
;    ; EXAMPLE:
;    ; invoke dwtoa,edx,ADDR buffer
;    ;
;    ; Uses: eax, ecx, edx.
;    ; -------------------------------------------------------------
;
;    push ebx
;    push esi
;    push edi
;
;    mov eax, dwValue
;    mov edi, [lpBuffer]
;
;    or eax,eax
;    jnz sign
;    
;  zero:
;    mov word ptr [edi],30h
;    jmp dw2asc
;    
;  sign:
;    jns pos
;    mov byte ptr [edi],'-'
;    neg eax
;    inc edi
;
;  pos:      
;    mov ecx,429496730
;    mov esi, edi
;
;    .while (eax > 0)
;      mov ebx,eax
;      mul ecx
;      mov eax,edx
;      lea edx,[edx*4+edx]
;      add edx,edx
;      sub ebx,edx
;      add bl,'0'
;      mov [edi],bl
;      inc edi
;    .endw
;
;    mov byte ptr [edi], 0       ; terminate the string
;
;    ; We now have all the digits, but in reverse order.
;
;    .while (esi < edi)
;      dec edi
;      mov al, [esi]
;      mov ah, [edi]
;      mov [edi], al
;      mov [esi], ah
;      inc esi
;    .endw
;
;    dw2asc:
;
;    pop edi
;    pop esi
;    pop ebx
;
;    ret
;
;dwtoa endp

; 

;StdIn proc lpszBuffer:DWORD,bLen:DWORD
;    LOCAL hInput :DWORD
;    LOCAL bRead  :DWORD
;
;    invoke GetStdHandle,STD_INPUT_HANDLE
;    mov hInput, eax
;
;    invoke SetConsoleMode,hInput,ENABLE_LINE_INPUT or ENABLE_ECHO_INPUT or ENABLE_PROCESSED_INPUT
;    invoke ReadFile,hInput,lpszBuffer,bLen,ADDR bRead,NULL
;    mov eax, bRead
;    ret
;
;StdIn endp

; 

StdOut proc lpszText:DWORD
;    invoke printf, addr strng, lpszText
    invoke fprintf, stdout, addr strng, lpszText
    ret
StdOut endp

; 

StrLen proc item:DWORD
    push    ebx

    push item
    call strlen

    pop     ebx
    ret

StrLen endp

; 

;FloatToBCD2	PROC	public uses esi edi
;    sub esp, 10
;    fbstp [esp]
;
;    lea esi, [esp+8]
;    lea edi, [szTemp]
;    mov ecx, 9
;
;    .REPEAT
;	mov al, [esi]		; xxxx xxxx AAAA BBBB
;	dec esi
;	rol ax, 12		; BBBB xxxx xxxx AAAA
;	rol ah, 4		; xxxx BBBB xxxx AAAA
;	and ax, 0f0fh		; 0000 BBBB 0000 AAAA
;	add ax, 3030h		; 3B3A
;	mov [edi], ax
;	add edi, 2
;	dec ecx
;    .UNTIL ZERO?
;
;    add esp, 10
;    ret
;
;FloatToBCD2	ENDP

; 

; 

;atodw proc String:DWORD
;    push esi
;    push edi
;
;    xor eax, eax
;    mov esi, [String]
;    xor ecx, ecx
;    xor edx, edx
;    mov al, [esi]
;    inc esi
;    cmp al, 2D
;    jne proceed
;    mov al, byte ptr [esi]
;    not edx
;    inc esi
;    jmp proceed
;
;  @@: 
;    sub al, 30h
;    lea ecx, dword ptr [ecx+4*ecx]
;    lea ecx, dword ptr [eax+2*ecx]
;    mov al, byte ptr [esi]
;    inc esi
;
;  proceed:
;    or al, al
;    jne @B
;    lea eax, dword ptr [edx+ecx]
;    xor eax, edx
;
;    pop edi
;    pop esi
;
;    ret
;
;atodw endp

; 

;PowerOf10	PROC	public
;    mov ecx, eax
;    .IF	(SDWORD PTR eax < 0)
;	neg eax
;    .ENDIF
;
;    fld1
;
;    mov dl, al
;    and edx, 0fh
;    .IF	(!ZERO?)
;	lea edx, [edx+edx*4]
;	fld ten_1[edx*2][-10]
;	fmulp st(1), st
;    .ENDIF
;
;    mov dl, al
;    shr dl, 4
;    and edx, 0fh
;    .IF (!ZERO?)
;	lea edx, [edx+edx*4]
;	fld ten_16[edx*2][-10]
;	fmulp st(1), st
;    .ENDIF
;
;    mov dl, ah
;    and edx, 1fh
;    .IF (!ZERO?)
;	lea edx, [edx+edx*4]
;	fld ten_256[edx*2][-10]
;	fmulp st(1), st
;    .ENDIF
;
;    .IF (SDWORD PTR ecx < 0)
;	fdivp st(1), st
;    .ELSE
;	fmulp st(1), st
;    .ENDIF
;
;    ret
;
;PowerOf10	ENDP

; 

;szLeft proc lpszSource:DWORD,lpszTarget:DWORD,ln:DWORD
;    push esi
;    push edi
;
;    cld
;    mov ecx, ln
;    mov esi, lpszSource
;    mov edx, ecx
;    mov edi, lpszTarget
;    and edx, 3
;
;    shr ecx, 2
;    rep movsd
;
;    lea ecx, [edx+1]
;    rep movsb
;
;    pop edi
;    pop esi
;    ret
;
;szLeft endp

; 

;szRight proc lpszSource:DWORD,lpszTarget:DWORD,ln:DWORD
;    LOCAL ln1:DWORD
;
;    invoke StrLen, lpszSource
;    mov ln1, eax
;
;    cld
;
;    mov esi, lpszSource
;    add esi, ln1
;    sub esi, ln
;    mov edi, lpszTarget
;    mov ecx, ln
;
;    shr ecx, 2
;    rep movsd
;
;    mov ecx, ln
;    and ecx, 3
;    rep movsb
;
;    mov al, 0
;    mov [edi], al
;
;    ret
;
;szRight endp

; 

;szMid proc lpszSource:DWORD,lpszTarget:DWORD,stPos:DWORD,ln:DWORD
;    cld
;
;    mov esi, lpszSource
;    mov edi, lpszTarget
;    add esi, stPos
;    mov ecx, ln
;
;    shr ecx, 2
;    rep movsd
;
;    mov ecx, ln
;    and ecx, 3
;    rep movsb
;
;    mov al, 0
;    mov [edi], al
;
;    ret
;
;szMid endp

; 
; 
; 

;end


